package pep;

/**This class defines the operations of Input nodes.*/
public class Input extends Node{
 /**stimulus bias*/   private double bias;
 /**stimulus signal*/ private double signal;

 /**Creates a new Input node.*/
 public Input(){
  super(RunTime.nEpisodes);
  threshold = .3;
  bias = 0;
  signal = 0;
 }

 /**Defines the input values for the node.
  * @param bs Amount of bias for the stimulus.
  * @param sig Amount of signal for the stimulus.*/
 public void param(double bs, double sig){
  bias = bs*java.lang.Math.random();
  signal = sig;
 }

 /**Calls the superclass method and activates Identity nodes.
  * @param stimNum The stimulus number.
  * @param isConflict Whether semantic conflict is present.*/
 public void activate(int stimNum, boolean isConflict){
  setInput();
  activate();
  if(isConflict) actOut(stimNum);
  else if(isTarget) actOut(stimNum);
 }

 /**Updates bias and sets the input for cycle.*/
 private void setInput(){
  bias = (bias*.996) + (signal*java.lang.Math.random()*.004);
  input += (bias + java.lang.Math.random())/2;
 }

 /**Sends activation to Identity node.
  * @param stimNum The stimulus number.*/
 public void actOut(int stimNum){
  if(activation>threshold)
  {
   double output = (activation-threshold)*java.lang.Math.random();
   if(isTarget) output*=6;
   output = range(output);
   RunTime.identities[stimNum].input += output;
   Identity.totInput += output;
  }
 }
}