package pep;

/**This Node subclass defines the operations of Response nodes.*/
public class Response extends Node{
 /**Amount of activation retrieved*/ public double retrieved;
 /**Total amount memory retrieved*/  public static double totRetrieved;

 /**Creates a new Response node.*/
 public Response(){
  super();
  threshold = .4;
  retrieved = 0;
 }

 /**Updates response activation.*/
 @Override
 public void activate(){
  retrieve();
  update();
 }

 /**Adds retrieved activation to input*/
 private void retrieve(){
  if(totRetrieved>0){
   double temp = retrieved-((totRetrieved-retrieved)/(RunTime.nResponses-1));
   if(totRetrieved>1) temp /= totRetrieved;
   temp -= .1;
   input += range(temp,.2);
   retrieved = 0;
  }
 }

 /**Clears totRetrieve*/
 public static void clear(){
  totRetrieved = 0;
 }
}